List Devices
List devices on the specified project. To learn more about devices, read Device Concept.
Listing, Sorting and Filtering Devices
This endpoint returns the list of devices in the specified project.
Sorting
The results from this endpoint can be ordered using the $orderby query parameter. Specify a list of field names, separated by commas
where each one can optionally specify asc or desc.
Sorting is valid on the following fields: created, createdBy, displayName, id, labels, metadata/created, metadata/displayName, metadata/name, name, status/alarmSeverity, status/beamHA/activeControllerDeviceName, status/beamHA/roles, status/currentSoftwareVersion, status/lastContact, status/model, status/rollbackSoftwareVersion, status/serialNumber, updated, updatedBy
Filtering
There are two ways to filter the set of returned devices from this endpoint - the first is to use the $filter query parameter, the second is to use the
$label_key and $label query parameters.
The $filter query parameter allows for devices to be filtered on the basis of fields in the schema using OData query syntax.
See this document for more details on the syntax used.
Filters are valid on the following fields: created, createdBy, createdByEmail, createdByName, displayName, id, labels, metadata/created, metadata/displayName, metadata/name, name, spec/siteName, status/alarmSeverity, status/beamHA/activeControllerDeviceName, status/beamHA/roles, status/currentSoftwareVersion, status/lastContact, status/model, status/rollbackSoftwareVersion, status/serialNumber, updated, updatedBy, updatedByEmail, updatedByName
$label_key and $label are specific to querying devices based on their labels. Labels are a set of key-value pairs that can be used to identify devices with
any arbitrary metadata you want, specifically for the purpose of retrieving relevant subsets of devices.
Examples:
?$top=10 - Returns only the first 10 devices from the list.
?$orderby=name desc - Sorts devices by name in descending order.
?$filter=name eq 'descriptive name' - Returns devices that match the provided name.
?$orderby=created desc - Sorts devices by creation date in descending order.
?$filter=created ge 2021-01-01T00:00:00Z - Returns devices created after January 1, 2021.
?$label=studio=paravalley - Returns devices with the label studio set to paravalley.
?$label=release-date~2023 - Returns devices with the label release-date set to a value that contains 2023.
?$label_key=studio&label_key=release-date - Returns devices with any value set for the studio label and the release-date label.
RBAC Capability Required: fleet.device.get
Authentication
Bearer authentication of the form Bearer <token>, where token is your auth token.
Path parameters
Query parameters
n that limits the number of items returned from a collection.
The service returns the number of available items up to but not greater than the specified value n.@odata.nextLink in the result object to enumerate the collection -
it will be present only if there's more than one page of entities.Response
200A list of devices
Loading schema details…
Errors
400Bad Request
Loading schema details…
401Unauthorized
Loading schema details…
403Forbidden
Loading schema details…
404Not Found
Loading schema details…
429Too Many Requests
Loading schema details…
500Internal Server Error
Loading schema details…